Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait MatchApproximation extends TreeAndTypeAnalysis with ScalaLogic with MatchTreeMaking
  Definition Classes
    patmat
-  trait MatchApproximator extends TreeMakers with TreesAndTypesDomain

  Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

  Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

  Definition Classes
    MatchApproximation
-  class TreeMakersToProps extends AnyRef
  Definition Classes
    MatchApproximator
- TreeMakerToProp
- condStrategy
- conservative

c

scala.tools.nsc.transform.patmat.MatchApproximation.MatchApproximator.TreeMakersToProps

# TreeMakerToProp

###

#### abstract class TreeMakerToProp extends (MatchApproximator.TreeMaker) => MatchApproximator.Prop

Source
  MatchAnalysis.scala

Linear Supertypes
(MatchApproximator.TreeMaker) => MatchApproximator.Prop, AnyRef, Any
Known Subclasses
conservative
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TreeMakerToProp
2. Function1
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new TreeMakerToProp()

### Abstract Value Members

1.  abstract def handleUnknown(tm: MatchApproximator.TreeMaker): MatchApproximator.Prop

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from TreeMakerToProp toany2stringadd[TreeMakerToProp] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (TreeMakerToProp, B)
   Implicit
     This member is added by an implicit conversion from TreeMakerToProp toArrowAssoc[TreeMakerToProp] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def andThen[A](g: (MatchApproximator.Prop) => A): (MatchApproximator.TreeMaker) => A
   Definition Classes
     Function1
   Annotations
     @unspecialized()
7.  def apply(tm: MatchApproximator.TreeMaker): MatchApproximator.Prop

   apply itself must render a faithful representation of the TreeMaker

   apply itself must render a faithful representation of the TreeMaker

   Concretely, True must only be used to represent a TreeMaker that is sure to match and that does not do any computation at all e.g., doCSE relies on apply itself being sound in this sense (since it drops TreeMakers that are approximated to True -- scala/bug#6077)

   handleUnknown may be customized by the caller to approximate further

   TODO: don't ignore outer-checks

   Definition Classes
     TreeMakerToProp → Function1
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
10.  def compose[A](g: (A) => MatchApproximator.TreeMaker): (A) => MatchApproximator.Prop
    Definition Classes
      Function1
    Annotations
      @unspecialized()
11.  def ensuring(cond: (TreeMakerToProp) => Boolean, msg: => Any): TreeMakerToProp
    Implicit
      This member is added by an implicit conversion from TreeMakerToProp toEnsuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (TreeMakerToProp) => Boolean): TreeMakerToProp
    Implicit
      This member is added by an implicit conversion from TreeMakerToProp toEnsuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: => Any): TreeMakerToProp
    Implicit
      This member is added by an implicit conversion from TreeMakerToProp toEnsuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): TreeMakerToProp
    Implicit
      This member is added by an implicit conversion from TreeMakerToProp toEnsuring[TreeMakerToProp] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
17.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from TreeMakerToProp toStringFormat[TreeMakerToProp] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
21.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
22.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
23.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
24.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
25.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
26.  def toString(): String
    Definition Classes
      Function1 → AnyRef → Any
27.  def updateSubstitution(tm: MatchApproximator.TreeMaker): Unit
28.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
29.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
30.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (TreeMakerToProp, B)
   Implicit
     This member is added by an implicit conversion from TreeMakerToProp toArrowAssoc[TreeMakerToProp] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from (MatchApproximator.TreeMaker) => MatchApproximator.Prop

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromTreeMakerToProp to any2stringadd[TreeMakerToProp]

### Inherited by implicit conversion StringFormat fromTreeMakerToProp to StringFormat[TreeMakerToProp]

### Inherited by implicit conversion Ensuring fromTreeMakerToProp to Ensuring[TreeMakerToProp]

### Inherited by implicit conversion ArrowAssoc fromTreeMakerToProp to ArrowAssoc[TreeMakerToProp]

### Ungrouped